diff -Nru libica-3.9.0/debian/libica4.symbols libica-4.0.0/debian/libica4.symbols
--- libica-3.9.0/debian/libica4.symbols	1970-01-01 01:00:00.000000000 +0100
+++ libica-4.0.0/debian/libica4.symbols	2022-01-31 13:19:06.000000000 +0100
@@ -0,0 +1,242 @@
+libica-cex.so.4 libica4 #MINVER#
+ ICA_DRBG_SHA512@LIBICA_3.0.0 4.0.0
+ LIBICA_3.0.0@LIBICA_3.0.0 4.0.0
+ LIBICA_3.0.0_FIPS@LIBICA_3.0.0_FIPS 4.0.0
+ LIBICA_3.1.0@LIBICA_3.1.0 4.0.0
+ LIBICA_3.2.0@LIBICA_3.2.0 4.0.0
+ LIBICA_3.3.0@LIBICA_3.3.0 4.0.0
+ LIBICA_3.4.0@LIBICA_3.4.0 4.0.0
+ LIBICA_3.5.0@LIBICA_3.5.0 4.0.0
+ LIBICA_3.6.0@LIBICA_3.6.0 4.0.0
+ ica_3des_cbc@LIBICA_3.0.0 4.0.0
+ ica_3des_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_3des_cfb@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_3des_ctr@LIBICA_3.0.0 4.0.0
+ ica_3des_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_3des_ecb@LIBICA_3.0.0 4.0.0
+ ica_3des_ofb@LIBICA_3.0.0 4.0.0
+ ica_aes_cbc@LIBICA_3.0.0 4.0.0
+ ica_aes_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_aes_ccm@LIBICA_3.0.0 4.0.0
+ ica_aes_cfb@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_aes_ctr@LIBICA_3.0.0 4.0.0
+ ica_aes_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_aes_ecb@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_initialize@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_intermediate@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_kma_ctx_free@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_ctx_new@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_get_tag@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_init@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_update@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_verify_tag@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_last@LIBICA_3.0.0 4.0.0
+ ica_aes_ofb@LIBICA_3.0.0 4.0.0
+ ica_aes_xts@LIBICA_3.0.0 4.0.0
+ ica_close_adapter@LIBICA_3.0.0 4.0.0
+ ica_des_cbc@LIBICA_3.0.0 4.0.0
+ ica_des_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_des_cfb@LIBICA_3.0.0 4.0.0
+ ica_des_cmac@LIBICA_3.0.0 4.0.0
+ ica_des_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_des_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_des_ctr@LIBICA_3.0.0 4.0.0
+ ica_des_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_des_ecb@LIBICA_3.0.0 4.0.0
+ ica_des_ofb@LIBICA_3.0.0 4.0.0
+ ica_drbg_generate@LIBICA_3.0.0 4.0.0
+ ica_drbg_health_test@LIBICA_3.0.0 4.0.0
+ ica_drbg_instantiate@LIBICA_3.0.0 4.0.0
+ ica_drbg_reseed@LIBICA_3.0.0 4.0.0
+ ica_drbg_uninstantiate@LIBICA_3.0.0 4.0.0
+ ica_ec_key_free@LIBICA_3.3.0 4.0.0
+ ica_ec_key_generate@LIBICA_3.3.0 4.0.0
+ ica_ec_key_get_private_key@LIBICA_3.3.0 4.0.0
+ ica_ec_key_get_public_key@LIBICA_3.3.0 4.0.0
+ ica_ec_key_init@LIBICA_3.3.0 4.0.0
+ ica_ec_key_new@LIBICA_3.3.0 4.0.0
+ ica_ecdh_derive_secret@LIBICA_3.3.0 4.0.0
+ ica_ecdsa_sign@LIBICA_3.3.0 4.0.0
+ ica_ecdsa_verify@LIBICA_3.3.0 4.0.0
+ ica_ed25519_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_ed25519_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_gen@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_get@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_set@LIBICA_3.6.0 4.0.0
+ ica_ed25519_sign@LIBICA_3.6.0 4.0.0
+ ica_ed25519_verify@LIBICA_3.6.0 4.0.0
+ ica_ed448_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_ed448_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_gen@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_get@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_set@LIBICA_3.6.0 4.0.0
+ ica_ed448_sign@LIBICA_3.6.0 4.0.0
+ ica_ed448_verify@LIBICA_3.6.0 4.0.0
+ ica_fips_status@LIBICA_3.0.0_FIPS 4.0.0
+ ica_get_functionlist@LIBICA_3.0.0 4.0.0
+ ica_get_version@LIBICA_3.0.0 4.0.0
+ ica_mp_mul512@LIBICA_3.3.0 4.0.0
+ ica_mp_sqr512@LIBICA_3.3.0 4.0.0
+ ica_open_adapter@LIBICA_3.0.0 4.0.0
+ ica_random_number_generate@LIBICA_3.0.0 4.0.0
+ ica_rsa_crt@LIBICA_3.0.0 4.0.0
+ ica_rsa_crt_key_check@LIBICA_3.0.0 4.0.0
+ ica_rsa_key_generate_crt@LIBICA_3.0.0 4.0.0
+ ica_rsa_key_generate_mod_expo@LIBICA_3.0.0 4.0.0
+ ica_rsa_mod_expo@LIBICA_3.0.0 4.0.0
+ ica_set_fallback_mode@LIBICA_3.3.0 4.0.0
+ ica_set_offload_mode@LIBICA_3.5.0 4.0.0
+ ica_set_stats_mode@LIBICA_3.5.0 4.0.0
+ ica_sha1@LIBICA_3.0.0 4.0.0
+ ica_sha224@LIBICA_3.0.0 4.0.0
+ ica_sha256@LIBICA_3.0.0 4.0.0
+ ica_sha384@LIBICA_3.0.0 4.0.0
+ ica_sha3_224@LIBICA_3.1.0 4.0.0
+ ica_sha3_256@LIBICA_3.1.0 4.0.0
+ ica_sha3_384@LIBICA_3.1.0 4.0.0
+ ica_sha3_512@LIBICA_3.1.0 4.0.0
+ ica_sha512@LIBICA_3.0.0 4.0.0
+ ica_sha512_224@LIBICA_3.4.0 4.0.0
+ ica_sha512_256@LIBICA_3.4.0 4.0.0
+ ica_shake_128@LIBICA_3.1.0 4.0.0
+ ica_shake_256@LIBICA_3.1.0 4.0.0
+ ica_x25519_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_x25519_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_x25519_derive@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_gen@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_get@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_set@LIBICA_3.6.0 4.0.0
+ ica_x448_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_x448_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_x448_derive@LIBICA_3.6.0 4.0.0
+ ica_x448_key_gen@LIBICA_3.6.0 4.0.0
+ ica_x448_key_get@LIBICA_3.6.0 4.0.0
+ ica_x448_key_set@LIBICA_3.6.0 4.0.0
+libica.so.4 libica4 #MINVER#
+ ICA_DRBG_SHA512@LIBICA_3.0.0 4.0.0
+ LIBICA_3.0.0@LIBICA_3.0.0 4.0.0
+ LIBICA_3.0.0_FIPS@LIBICA_3.0.0_FIPS 4.0.0
+ LIBICA_3.1.0@LIBICA_3.1.0 4.0.0
+ LIBICA_3.2.0@LIBICA_3.2.0 4.0.0
+ LIBICA_3.3.0@LIBICA_3.3.0 4.0.0
+ LIBICA_3.4.0@LIBICA_3.4.0 4.0.0
+ LIBICA_3.5.0@LIBICA_3.5.0 4.0.0
+ LIBICA_3.6.0@LIBICA_3.6.0 4.0.0
+ ica_3des_cbc@LIBICA_3.0.0 4.0.0
+ ica_3des_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_3des_cfb@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_3des_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_3des_ctr@LIBICA_3.0.0 4.0.0
+ ica_3des_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_3des_ecb@LIBICA_3.0.0 4.0.0
+ ica_3des_ofb@LIBICA_3.0.0 4.0.0
+ ica_aes_cbc@LIBICA_3.0.0 4.0.0
+ ica_aes_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_aes_ccm@LIBICA_3.0.0 4.0.0
+ ica_aes_cfb@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_aes_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_aes_ctr@LIBICA_3.0.0 4.0.0
+ ica_aes_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_aes_ecb@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_initialize@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_intermediate@LIBICA_3.0.0 4.0.0
+ ica_aes_gcm_kma_ctx_free@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_ctx_new@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_get_tag@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_init@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_update@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_kma_verify_tag@LIBICA_3.2.0 4.0.0
+ ica_aes_gcm_last@LIBICA_3.0.0 4.0.0
+ ica_aes_ofb@LIBICA_3.0.0 4.0.0
+ ica_aes_xts@LIBICA_3.0.0 4.0.0
+ ica_close_adapter@LIBICA_3.0.0 4.0.0
+ ica_des_cbc@LIBICA_3.0.0 4.0.0
+ ica_des_cbc_cs@LIBICA_3.0.0 4.0.0
+ ica_des_cfb@LIBICA_3.0.0 4.0.0
+ ica_des_cmac@LIBICA_3.0.0 4.0.0
+ ica_des_cmac_intermediate@LIBICA_3.0.0 4.0.0
+ ica_des_cmac_last@LIBICA_3.0.0 4.0.0
+ ica_des_ctr@LIBICA_3.0.0 4.0.0
+ ica_des_ctrlist@LIBICA_3.0.0 4.0.0
+ ica_des_ecb@LIBICA_3.0.0 4.0.0
+ ica_des_ofb@LIBICA_3.0.0 4.0.0
+ ica_drbg_generate@LIBICA_3.0.0 4.0.0
+ ica_drbg_health_test@LIBICA_3.0.0 4.0.0
+ ica_drbg_instantiate@LIBICA_3.0.0 4.0.0
+ ica_drbg_reseed@LIBICA_3.0.0 4.0.0
+ ica_drbg_uninstantiate@LIBICA_3.0.0 4.0.0
+ ica_ec_key_free@LIBICA_3.3.0 4.0.0
+ ica_ec_key_generate@LIBICA_3.3.0 4.0.0
+ ica_ec_key_get_private_key@LIBICA_3.3.0 4.0.0
+ ica_ec_key_get_public_key@LIBICA_3.3.0 4.0.0
+ ica_ec_key_init@LIBICA_3.3.0 4.0.0
+ ica_ec_key_new@LIBICA_3.3.0 4.0.0
+ ica_ecdh_derive_secret@LIBICA_3.3.0 4.0.0
+ ica_ecdsa_sign@LIBICA_3.3.0 4.0.0
+ ica_ecdsa_verify@LIBICA_3.3.0 4.0.0
+ ica_ed25519_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_ed25519_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_gen@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_get@LIBICA_3.6.0 4.0.0
+ ica_ed25519_key_set@LIBICA_3.6.0 4.0.0
+ ica_ed25519_sign@LIBICA_3.6.0 4.0.0
+ ica_ed25519_verify@LIBICA_3.6.0 4.0.0
+ ica_ed448_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_ed448_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_gen@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_get@LIBICA_3.6.0 4.0.0
+ ica_ed448_key_set@LIBICA_3.6.0 4.0.0
+ ica_ed448_sign@LIBICA_3.6.0 4.0.0
+ ica_ed448_verify@LIBICA_3.6.0 4.0.0
+ ica_fips_status@LIBICA_3.0.0_FIPS 4.0.0
+ ica_get_functionlist@LIBICA_3.0.0 4.0.0
+ ica_get_version@LIBICA_3.0.0 4.0.0
+ ica_mp_mul512@LIBICA_3.3.0 4.0.0
+ ica_mp_sqr512@LIBICA_3.3.0 4.0.0
+ ica_open_adapter@LIBICA_3.0.0 4.0.0
+ ica_random_number_generate@LIBICA_3.0.0 4.0.0
+ ica_rsa_crt@LIBICA_3.0.0 4.0.0
+ ica_rsa_crt_key_check@LIBICA_3.0.0 4.0.0
+ ica_rsa_key_generate_crt@LIBICA_3.0.0 4.0.0
+ ica_rsa_key_generate_mod_expo@LIBICA_3.0.0 4.0.0
+ ica_rsa_mod_expo@LIBICA_3.0.0 4.0.0
+ ica_set_fallback_mode@LIBICA_3.3.0 4.0.0
+ ica_set_offload_mode@LIBICA_3.5.0 4.0.0
+ ica_set_stats_mode@LIBICA_3.5.0 4.0.0
+ ica_sha1@LIBICA_3.0.0 4.0.0
+ ica_sha224@LIBICA_3.0.0 4.0.0
+ ica_sha256@LIBICA_3.0.0 4.0.0
+ ica_sha384@LIBICA_3.0.0 4.0.0
+ ica_sha3_224@LIBICA_3.1.0 4.0.0
+ ica_sha3_256@LIBICA_3.1.0 4.0.0
+ ica_sha3_384@LIBICA_3.1.0 4.0.0
+ ica_sha3_512@LIBICA_3.1.0 4.0.0
+ ica_sha512@LIBICA_3.0.0 4.0.0
+ ica_sha512_224@LIBICA_3.4.0 4.0.0
+ ica_sha512_256@LIBICA_3.4.0 4.0.0
+ ica_shake_128@LIBICA_3.1.0 4.0.0
+ ica_shake_256@LIBICA_3.1.0 4.0.0
+ ica_x25519_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_x25519_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_x25519_derive@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_gen@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_get@LIBICA_3.6.0 4.0.0
+ ica_x25519_key_set@LIBICA_3.6.0 4.0.0
+ ica_x448_ctx_del@LIBICA_3.6.0 4.0.0
+ ica_x448_ctx_new@LIBICA_3.6.0 4.0.0
+ ica_x448_derive@LIBICA_3.6.0 4.0.0
+ ica_x448_key_gen@LIBICA_3.6.0 4.0.0
+ ica_x448_key_get@LIBICA_3.6.0 4.0.0
+ ica_x448_key_set@LIBICA_3.6.0 4.0.0
diff -Nru libica-3.9.0/debian/patches/series libica-4.0.0/debian/patches/series
--- libica-3.9.0/debian/patches/series	1970-01-01 01:00:00.000000000 +0100
+++ libica-4.0.0/debian/patches/series	2022-01-31 13:19:06.000000000 +0100
@@ -0,0 +1,10 @@
+977fe8ac713f9ff3101ce9882e23d0183fb46ec8.patch
+553977ef505b43c7d17056369ed518a971d43d68.patch
+b41addd200c0938c6c10202da08ad5f7df940e18.patch
+6031ec80a5ada52609822fed4a6bd2cccafe5563.patch
+b49cf457659a4baf382b3828d89823497bb00f6e.patch
+7e6e303e6aef019047eb6dfcdedbfe7da2a88526.patch
+28fa931bed9e6847137829952a3e7cc6091bd071.patch
+cc44f18383ec6dc01a05abd6c25a1dec8efe84cb.patch
+9c6431f49a9fe0d574722954e018b4cba6ab085b.patch
+5aa9366c236a6d17570403ef81c65e4f5f91a8af.patch
diff -Nru libica-3.9.0/include/ica_api.h libica-4.0.0/include/ica_api.h
--- libica-3.9.0/include/ica_api.h	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/include/ica_api.h	2021-12-06 12:01:54.000000000 +0100
@@ -597,7 +597,7 @@
 ICA_EXPORT
 unsigned int ica_sha1(unsigned int message_part,
 		      unsigned int input_length,
-		      unsigned char *input_data,
+		      const unsigned char *input_data,
 		      sha_context_t *sha_context,
 		      unsigned char *output_data);
 
@@ -643,7 +643,7 @@
 ICA_EXPORT
 unsigned int ica_sha224(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha256_context_t *sha256_context,
 			unsigned char *output_data);
 
@@ -687,7 +687,7 @@
 ICA_EXPORT
 unsigned int ica_sha256(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha256_context_t *sha256_context,
 			unsigned char *output_data);
 
@@ -733,7 +733,7 @@
 ICA_EXPORT
 unsigned int ica_sha384(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha512_context_t *sha512_context,
 			unsigned char *output_data);
 
@@ -777,7 +777,7 @@
 ICA_EXPORT
 unsigned int ica_sha512(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha512_context_t *sha512_context,
 			unsigned char *output_data);
 
@@ -821,7 +821,7 @@
 ICA_EXPORT
 unsigned int ica_sha512_224(unsigned int message_part,
 			    uint64_t input_length,
-			    unsigned char *input_data,
+			    const unsigned char *input_data,
 			    sha512_context_t *sha512_context,
 			    unsigned char *output_data);
 
@@ -864,42 +864,42 @@
  */ICA_EXPORT
 unsigned int ica_sha512_256(unsigned int message_part,
 			    uint64_t input_length,
-			    unsigned char *input_data,
+			    const unsigned char *input_data,
 			    sha512_context_t *sha512_context,
 			    unsigned char *output_data);
 
 ICA_EXPORT
 unsigned int ica_sha3_224(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_224_context_t *sha3_224_context,
 			unsigned char *output_data);
 
 ICA_EXPORT
 unsigned int ica_sha3_256(unsigned int message_part,
 			unsigned int input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_256_context_t *sha3_256_context,
 			unsigned char *output_data);
 
 ICA_EXPORT
 unsigned int ica_sha3_384(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_384_context_t *sha3_384_context,
 			unsigned char *output_data);
 
 ICA_EXPORT
 unsigned int ica_sha3_512(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			sha3_512_context_t *sha3_512_context,
 			unsigned char *output_data);
 
 ICA_EXPORT
 unsigned int ica_shake_128(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			shake_128_context_t *shake_128_context,
 			unsigned char *output_data,
 			unsigned int output_length);
@@ -907,7 +907,7 @@
 ICA_EXPORT
 unsigned int ica_shake_256(unsigned int message_part,
 			uint64_t input_length,
-			unsigned char *input_data,
+			const unsigned char *input_data,
 			shake_256_context_t *shake_256_context,
 			unsigned char *output_data,
 			unsigned int output_length);
@@ -1184,8 +1184,8 @@
 int ica_ed25519_key_set(ICA_ED25519_CTX *ctx, const unsigned char priv[32],
 			const unsigned char pub[32]);
 ICA_EXPORT
-int ica_ed448_key_set(ICA_ED448_CTX *ctx, const unsigned char priv[56],
-		      const unsigned char pub[56]);
+int ica_ed448_key_set(ICA_ED448_CTX *ctx, const unsigned char priv[57],
+		      const unsigned char pub[57]);
 
 /*
  * Copy the private and public key from the context. MSA9 required.
@@ -1351,7 +1351,7 @@
  */
 ICA_EXPORT
 unsigned int ica_rsa_mod_expo(ica_adapter_handle_t adapter_handle,
-			      unsigned char *input_data,
+			      const unsigned char *input_data,
 			      ica_rsa_key_mod_expo_t *rsa_key,
 			      unsigned char *output_data);
 
@@ -1380,7 +1380,7 @@
  */
 ICA_EXPORT
 unsigned int ica_rsa_crt(ica_adapter_handle_t adapter_handle,
-			 unsigned char *input_data,
+			 const unsigned char *input_data,
 			 ica_rsa_key_crt_t *rsa_key,
 			 unsigned char *output_data);
 
@@ -1400,227 +1400,6 @@
 unsigned int ica_rsa_crt_key_check(ica_rsa_key_crt_t *rsa_key);
 
 /**
- * @deprecated, use ica_des_ecb() or ica_des_cbc() instead.
- *
- * Encrypt data using a single length DES key.
- * @param mode Specifies the operational mode and must be:
- *	       MODE_ECB - Use Electronic Code Book mode
- *	       MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. It has to be a multiple of the
- * cipher block which has a size of 8 byte.
- * @param input_data
- * Pointer to the input data data to be encrypted. Must be a multiple of the
- * cipher to use hw acceleration.
- * @param iv
- * Pointer to a valid 8 byte initialization vector when using CBC mode.
- * @param des_key
- * Pointer to a single length DES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting encrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_des_encrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_des_vector_t *iv,
-			     ica_des_key_single_t *des_key,
-			     unsigned char *output_data);
-
-/**
- * @deprecated, use ica_des_ecb() or ica_des_cbc() instead.
- *
- * Decrypt data using a single length DES key.
- * @param mode
- * Specifies the operational mode and must be:
- * 	MODE_ECB - Use Electronic Code Book mode
- *	MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. It has to be a multiple of the
- * cipher block which has a size of 8 byte.
- * @param input_data
- * Pointer to the input data data to be decrypted. Must be a multiple of the
- * cipher to use hw acceleration.
- * @param iv
- * Pointer to a valid 8 byte initialization vector when using CBC mode.
- * @param des_key
- * Pointer to a single length DES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting decrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_des_decrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_des_vector_t *iv,
-			     ica_des_key_single_t *des_key,
-			     unsigned char *output_data);
-
-/**
- * @deprecated, use ica_3des_ecb() or ica_3des_cbc() instead.
- *
- * Encrypt data using a triple length DES key.
- * @param mode
- * Specifies the operational mode and must be:
- * 	MODE_ECB - Use Electronic Code Book mode
- *	MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. It has to be a multiple of the
- * cipher block which has a size of 8 byte.
- * @param input_data
- * Pointer to the input data data to be encrypted. Must be a multiple of the
- * cipher block to use hw acceleration.
- * @param iv
- * Pointer to a valid 8 byte initialization vector when using CBC mode.
- * @param des_key
- * Pointer to a triple length DES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting encrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_3des_encrypt(unsigned int mode,
-			      unsigned int data_length,
-			      unsigned char *input_data,
-			      ica_des_vector_t *iv,
-			      ica_des_key_triple_t *des_key,
-			      unsigned char *output_data);
-
-/**
- * @deprecated, use ica_3des_ecb() or ica_3des_cbc() instead.
- *
- * Decrypt data using a triple length DES key.
- * @param mode
- * Specifies the operational mode and must be:
- * 	MODE_ECB - Use Electronic Code Book mode
- *	MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. It has to be a multiple of the
- * cipher block which has a size of 8 byte.
- * @param input_data
- * Pointer to the input data data to be decrypted. Must be a multiple of the
- * cipher block to use hw acceleration.
- * @param iv
- * Pointer to a valid 8 byte initialization vector when using CBC mode.
- * @param des_key
- * Pointer to a triple length DES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting decrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_3des_decrypt(unsigned int mode,
-			      unsigned int data_length,
-			      unsigned char *input_data,
-			      ica_des_vector_t *iv,
-			      ica_des_key_triple_t *des_key,
-			      unsigned char *output_data);
-
-/**
- * @deprecated, use ica_aes_ecb() or ica_aes_cbc() instead.
- *
- * Encrypt data using AES (key_length is 16, 24, or 32)
- * @param mode
- * Specifies the operational mode and must be:
- * 	MODE_ECB - Use Electronic Code Book mode
- *	MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. Input data length has to be
- * a multiple of the AES block length, which is 16 bytes.
- * @param input_data
- * Pointer to the input data data to be encrypted. Must be a multiple of the
- * cipher block to use hw acceleration.
- * @param iv
- * Pointer to a valid 16 byte initialization vector when using CBC mode.
- * @param key_length
- * Length of the AES key being used.
- * @param aes_key
- * Pointer to an AES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting encrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_aes_encrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_aes_vector_t *iv,
-			     unsigned int key_length,
-			     unsigned char *aes_key,
-			     unsigned char *output_data);
-
-/**
- * @deprecated, use ica_aes_ecb() or ica_aes_cbc() instead.
- *
- * Decrypt data using AES (key_length is 16, 24, or 32)
- * @param mode
- * Specifies the operational mode and must be:
- * 	MODE_ECB - Use Electronic Code Book mode
- *	MODE_CBC - Use Cipher Block Chaining mode
- * @param data_length
- * Specifies the byte length of the input data. Input data length has to be
- * a multiple of the AES block length, which is 16 bytes.
- * @param input_data
- * Pointer to the input data to be decrypted. Must be a multiple of the
- * cipher block to use hw acceleration.
- * @param iv
- * Pointer to a valid 16 byte initialization vector when using CBC mode.
- * @param key_length
- * Length of the AES key being used.
- * @param aes_key
- * Pointer to an AES key.
- * @param output_data
- * Pointer to the buffer to contain the resulting decrypted data. Must be a
- * multiple of the cipher block and at least as big as the buffer for
- * input_data.
- *
- * @return 0 if successful.
- * EINVAL if at least one invalid parameter is given.
- * EIO if the operation fails. This should never happen.
- */
-/* XXX next major: remove */
-ICA_EXPORT ICA_DEPRECATED
-unsigned int ica_aes_decrypt(unsigned int mode,
-			     unsigned int data_length,
-			     unsigned char *input_data,
-			     ica_aes_vector_t *iv,
-			     unsigned int key_length,
-			     unsigned char *aes_key,
-			     unsigned char *output_data);
-
-/**
  * Encrypt or decrypt data with an DES key using Electronic Cook Book (ECB)
  * mode as described in NIST Special Publication 800-38A Chapter 6.1.
  *
@@ -3596,15 +3375,6 @@
 ICA_EXPORT
 unsigned int ica_get_version(libica_version_info *version_info);
 
-/* XXX next major: dont export, move to s390_crypto.h */
-ICA_EXPORT ICA_DEPRECATED
-int s390_initialize_functionlist(void);
-
-/* XXX next major: dont export, move to s390_crypto.h */
-ICA_EXPORT ICA_DEPRECATED
-int s390_get_functionlist(libica_func_list_element *pmech_list,
-			  unsigned int *pmech_list_len);
-
 /**
  * Function that returns a list of crypto mechanisms supported by libica.
  * @param pmech_list
@@ -3868,11 +3638,6 @@
 ICA_EXPORT
 int ica_mp_sqr512(uint64_t r[16], const uint64_t a[8]);
 
-#ifdef ICA_FIPS
-/*
- * Additional FIPS interfaces are available for built-in FIPS mode.
- */
-
 /*
  * FIPS status output interface.
  *
@@ -3882,6 +3647,11 @@
 ICA_EXPORT
 int ica_fips_status(void);
 
+#ifdef ICA_FIPS
+/*
+ * Additional FIPS interfaces are available for built-in FIPS mode.
+ */
+
 /*
  * FIPS powerups tests.
  *
diff -Nru libica-3.9.0/libica.spec libica-4.0.0/libica.spec
--- libica-3.9.0/libica.spec	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/libica.spec	2021-12-06 12:01:54.000000000 +0100
@@ -1,5 +1,5 @@
 Name:          libica
-Version:       3.9.0
+Version:       4.0.0
 Release:       1%{?dist}
 Summary:       Interface library to the ICA device driver
 
diff -Nru libica-3.9.0/src/fips.c libica-4.0.0/src/fips.c
--- libica-3.9.0/src/fips.c	2021-10-13 16:00:38.000000000 +0200
+++ libica-4.0.0/src/fips.c	2021-12-06 12:01:54.000000000 +0100
@@ -59,6 +59,7 @@
 #define HMAC_SUFFIX ".hmac"
 #define READ_BUFFER_LENGTH 16384
 
+#ifndef ICA_INTERNAL_TEST
 /*
  * The hard-coded HMAC key to be optionally provided for the library
  * integrity test. The recommended key size for HMAC-SHA256 is 64 bytes.
@@ -69,6 +70,8 @@
 	"0000000000000000000000000000000000000000000000000000000000000000"
 	"0000000000000000000000000000000000000000000000000000000000000000";
 
+#endif /* ICA_INTERNAL_TEST */
+
 int fips;
 
 #define LIBICA_FIPS_CONFIG		LIBICA_CONFDIR "/libica/openssl3-fips.cnf"
@@ -254,9 +257,22 @@
 
 		fips |= ICA_FIPS_MODE;
 #endif
+	} else {
+		/* kernel fips flag == 0, load default provider in case we are
+		 * running with openssl 3.0 */
+#if OPENSSL_VERSION_PREREQ(3, 0)
+		openssl_provider = OSSL_PROVIDER_load(openssl_libctx, "default");
+		if (openssl_provider == NULL) {
+			syslog(LOG_ERR, "Libica: failed to load default provider\n");
+			fips |= ICA_FIPS_INTEGRITY;
+			return;
+		}
+#endif
 	}
 }
 
+#ifndef ICA_INTERNAL_TEST
+
 static char *make_hmac_path(const char *origpath)
 {
 	char *path;
@@ -469,6 +485,7 @@
 
 	syslog(LOG_INFO, msg3);
 }
+#endif /* ICA_INTERNAL_TEST */
 
 void
 fips_powerup_tests(void)
@@ -1288,10 +1305,33 @@
 	const struct rsa_tv *tv;
 	size_t i, keylen, crtparamlen;
 	unsigned char *out;
+	libica_func_list_element* libica_func_list;
+	unsigned int count;
 
 	if (ica_open_adapter(&ah))
 		return 1;
 
+	if (ica_get_functionlist(NULL, &count) != 0)
+		goto _err_;
+
+	libica_func_list = malloc(sizeof(libica_func_list_element) * count);
+	if (!libica_func_list)
+		goto _err_;
+
+	if (ica_get_functionlist(libica_func_list, &count) != 0)
+		goto _err_;
+
+	for (i = 0; i < count; i++) {
+		if (libica_func_list[i].mech_mode_id == RSA_CRT &&
+			libica_func_list[i].flags == 0) {
+			/* RSA_CRT, and probably also RSA_ME, not available, skip test.
+			 * Looks like we don't have cards nor sw fallbacks. */
+			free(libica_func_list);
+			ica_close_adapter(ah);
+			return 0;
+		}
+	}
+
 	for (i = 0; i < RSA_TV_LEN; i++) {
 		tv = &RSA_TV[i];
 
@@ -1340,10 +1380,12 @@
 		free(privkey.dq);
 		free(privkey.qInverse);
 	}
+	free(libica_func_list);
 	ica_close_adapter(ah);
 	return 0;
 
 _err_:
+	free(libica_func_list);
 	ica_close_adapter(ah);
 	free(out);
 	free(pubkey.exponent);
